/******************************************************************************

            Copyright (c) 1996 - 2004  --  University of Washington

******************************************************************************/

#include "stand_inc.h"

int _REG_TOTELMS(_region reg) {
  int i, numelms;

  for (numelms = 1, i = 0; i < _NUMDIMS(reg); i++) {
    numelms *= _REG_NUMELMS(reg, i);
  }
  return numelms;
}

void _region_register_array(_region_fnc reg, _array_fnc arr) {
  _array_list* tmp = _zmalloc(sizeof(_array_list), "region array list node");

  _REG_ARRLIST_ARR(tmp) = arr;
  _REG_ARRLIST_NEXT(tmp) = _REG_ARRLIST(reg);
  _REG_ARRLIST(reg) = tmp;
}

void _region_unregister_array(_region_fnc reg, _array arr) {
  _array_list* tmp;
  _array_list* prev;

  prev = NULL;
  tmp = _REG_ARRLIST(reg);
  while (tmp) {
    if (_REG_ARRLIST_ARR(tmp) == arr) {
      break;
    }
    prev = tmp;
    tmp = _REG_ARRLIST_NEXT(tmp);
  }
  if (!tmp) {
    _RT_ANY_FATAL1("Array %s cannot be unregistered", _ARR_LABEL(arr));
  }
  if (prev) {
    _REG_ARRLIST_NEXT(prev) = _REG_ARRLIST_NEXT(tmp);
  }
  else {
    _REG_ARRLIST(reg) = _REG_ARRLIST_NEXT(tmp);
  }
  _zfree(tmp, "region array list node");
}

void _print_region_hierarchy(_region reg) {
  _array_list* tmp = _REG_ARRLIST(reg);

  _SCALAR_FPRINTF1(zout, "Region %s\n", _REG_LABEL(reg));
  while (tmp) {
    _SCALAR_FPRINTF1(zout, "Array %s\n", _ARR_LABEL(_REG_ARRLIST_ARR(tmp)));
    tmp = _REG_ARRLIST_NEXT(tmp);
  }
}
